classification
Title: 3.5 install fails poorly on Windows XP
Type: behavior Stage: resolved
Components: Installation, Windows Versions: Python 3.6, Python 3.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: steve.dower Nosy List: UlFie, djoudi, larry, paul.moore, pwatson@phs.org, python-dev, steve.dower, tim.golden, zach.ware
Priority: normal Keywords:

Created on 2015-09-16 16:18 by pwatson@phs.org, last changed 2015-10-11 23:43 by steve.dower. This issue is now closed.

Messages (8)
msg250852 - (view) Author: Paul (pwatson@phs.org) Date: 2015-09-16 16:18
Running the installer on an unsupported system (such as Windows XP)should fail gracefully and not just leave the user hanging.

https://mail.python.org/pipermail/python-list/2015-September/696789.html
msg250853 - (view) Author: Paul (pwatson@phs.org) Date: 2015-09-16 16:19
Installing on an unsupported platform should fail gracefully.

https://mail.python.org/pipermail/python-list/2015-September/696789.html
msg250861 - (view) Author: Djoudi Benarfa (djoudi) Date: 2015-09-16 19:54
The Python installer could check what operating system the user is trying to install python on and if it's not supported then, information him, and maybe redirect him to the correct python version.
msg250921 - (view) Author: Ulrich Fieseler (UlFie) Date: 2015-09-17 21:49
Even better: Clearly (and ASAP!) document on download page that 3.4.3 is the last version usable in XP! This avoids useless downloads and a lot of confusion as clicking somewhere in the erroneously white area above the `Cancel' button in the 3.5.0 installer window will get the installation running (see mailing list thread quoted), only to experience error messages like `python.exe is not a valid win32 application' (translated from what I get in German, exact wording in English might be different) when trying to run the interpreter. That message is not helpful at all, either! Actually, searching the web for that message yields various suggestions how to fix the problem (useless here), taking me two days before I finally found the thread on the mailing list. :-( :-(
msg251376 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-09-23 01:03
I don't have any XP machines handy, but I'll see if I can at least get an early termination from the installer rather than broken UI.

IIRC, Larry was against having prominent warnings about unsupported platforms on the download page, but with python.org being the official source of Windows binaries and XP still having an overly large market share, maybe it needs to be there? (Though it probably won't ever be prominent *enough*, and we'll still have people miss it.)
msg251442 - (view) Author: Tim Golden (tim.golden) * (Python committer) Date: 2015-09-23 20:01
I'd just bail as early as poss. from the installer. If it's possible to 
detect Windows versions, stick something like "The last version to 
support WinXP is 3.4". If that's too tricky, perhaps something "Your 
system may be unsupported. Please try an earlier version of Python"
msg252830 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2015-10-11 23:41
New changeset 2316bc881eea by Steve Dower in branch '3.5':
Issue #25143: Improves installer error messages for unsupported platforms.
https://hg.python.org/cpython/rev/2316bc881eea

New changeset 2c384ba13fdd by Steve Dower in branch 'default':
Issue #25143: Improves installer error messages for unsupported platforms.
https://hg.python.org/cpython/rev/2c384ba13fdd
msg252831 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-10-11 23:43
Still need to validate the fix on WinXP, as I'm not 100% certain that enough UI will appear to show the user the error, but we will now bail right at the start and link to either help pages for installing updates (for Vista/7) or Python 3.4 (for pre-Vista).
History
Date User Action Args
2015-10-11 23:43:12steve.dowersetstatus: open -> closed
resolution: fixed
messages: + msg252831

stage: needs patch -> resolved
2015-10-11 23:41:09python-devsetnosy: + python-dev
messages: + msg252830
2015-09-23 20:01:34tim.goldensetmessages: + msg251442
2015-09-23 01:03:12steve.dowersetnosy: + larry
messages: + msg251376
2015-09-17 21:49:44UlFiesetnosy: + UlFie
messages: + msg250921
2015-09-16 19:54:17djoudisetnosy: + djoudi
messages: + msg250861
2015-09-16 16:41:02zach.waresetassignee: steve.dower
stage: needs patch
components: + Installation
versions: + Python 3.6
2015-09-16 16:25:46brett.cannonsetnosy: + paul.moore, tim.golden, zach.ware, steve.dower
components: + Windows, - Installation
2015-09-16 16:19:31pwatson@phs.orgsetmessages: + msg250853
2015-09-16 16:18:06pwatson@phs.orgcreate